// CurveFitEditView.cpp : CCurveFitEditView NX̓̒`s܂B
//

#include "stdafx.h"
#include "CurveFit.h"
#include "CurveFitDoc.h"
#include "CntrItem.h"
#include "CurveFitEditView.h"
#include "..\IniFile.h"
#include "resource.h"

extern CIniFile *IniFile;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCurveFitEditView

IMPLEMENT_DYNCREATE(CCurveFitEditView, CRichEditView)

BEGIN_MESSAGE_MAP(CCurveFitEditView, CRichEditView)
	ON_WM_CONTEXTMENU()
	//{{AFX_MSG_MAP(CCurveFitEditView)
	ON_WM_DESTROY()
	ON_COMMAND(ID_VIEW_SELECTEDITORFONT, OnViewSelecteditorfont)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCurveFitEditView NX̍\z/

CCurveFitEditView::CCurveFitEditView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
}

CCurveFitEditView::~CCurveFitEditView()
{
}

BOOL CCurveFitEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CRichEditView::PreCreateWindow(cs);
}

void CCurveFitEditView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();

	// ̗]ݒ肵܂ (720 twips = 1/2 inch).
	SetMargins(CRect(720, 720, 720, 720));
}

/////////////////////////////////////////////////////////////////////////////
// CCurveFitEditView NẌ

BOOL CCurveFitEditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}


void CCurveFitEditView::OnDestroy()
{
	// ŎɃACeANeBx[g܂; ͕r[
	// gpĂꍇɂ͏dvłB
   CRichEditView::OnDestroy();
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
}


/////////////////////////////////////////////////////////////////////////////
// CCurveFitEditView NX̐ff

#ifdef _DEBUG
void CCurveFitEditView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CCurveFitEditView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CCurveFitDoc* CCurveFitEditView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCurveFitDoc)));
	return (CCurveFitDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCurveFitEditView NX̃bZ[W nh

int CCurveFitEditView::ClearText()
{
	SetWindowText("");
	return 1;
}

int CCurveFitEditView::ReadTextFile(LPCSTR file)
{
	FILE *in;
	char str[256];
	if((in = fopen(file, "rb")) == NULL) return -1;
	while(!feof(in))
	{
		*str = 0;
		fgets(str, 256, in);
		GetRichEditCtrl().ReplaceSel(str);
	}
	fclose(in);
	return 1;
}

void CCurveFitEditView::OnViewSelecteditorfont() 
{
	// TODO: ̈ʒuɃR}h nhp̃R[hǉĂ
	CFontDialog fd(&m_EditorLogFont);
	
	if(fd.DoModal() == IDOK)
	{
		LOGFONT lf;
		fd.GetCurrentFont(&lf);
		memcpy(&m_EditorLogFont, &lf, sizeof(LOGFONT));
		IniFile->WriteString("EditorView", "EditorFontFaceName", m_EditorLogFont.lfFaceName);
		IniFile->WriteInt("EditorView", "EditorFontHeight", m_EditorLogFont.lfHeight);
	}
	CFont font;
	font.CreateFontIndirect(&m_EditorLogFont);
	SetFont(&font);
	Invalidate();
}

int CCurveFitEditView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CRichEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	memset(&m_EditorLogFont, 0, sizeof(LOGFONT));
	IniFile->GetString("EditorView", "EditorFontFaceName", "", m_EditorLogFont.lfFaceName);
	if(*(m_EditorLogFont.lfFaceName) != 0)
	{
		m_EditorLogFont.lfHeight = IniFile->GetInt("EditorView", "EditorFontHeight", 0);
		m_EditorLogFont.lfEscapement = 0;
		m_EditorLogFont.lfItalic = 0;
		m_EditorLogFont.lfStrikeOut = 0;
		m_EditorLogFont.lfUnderline = 0;
	}
	else
	{
		CFont *pFont = GetFont();
		if(pFont)
			pFont->GetLogFont(&m_EditorLogFont);
		else
		{
			memset(&m_EditorLogFont, 0, sizeof(LOGFONT));
			strcpy(m_EditorLogFont.lfFaceName, "Times New Roman");
			m_EditorLogFont.lfHeight = -24;
		}
		m_EditorLogFont.lfEscapement = 0;
		m_EditorLogFont.lfItalic = 0;
		m_EditorLogFont.lfStrikeOut = 0;
		m_EditorLogFont.lfUnderline = 0;
	}
	CFont font;
	font.CreateFontIndirect(&m_EditorLogFont);
	SetFont(&font);
	
	return 0;
}

void CCurveFitEditView::OnContextMenu(CWnd*, CPoint point)
{

	// CG: ̃ubN̓|bvAbv j[ R|[lgɂĒǉ܂
	{
		if (point.x == -1 && point.y == -1){
			//L[Xg[N̔
			CRect rect;
			GetClientRect(rect);
			ClientToScreen(rect);

			point = rect.TopLeft();
			point.Offset(5, 5);
		}

		CMenu menu;
		VERIFY(menu.LoadMenu(CG_IDR_POPUP_CURVE_FIT_EDIT_VIEW));

		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);
		CWnd* pWndPopupOwner = this;

		while (pWndPopupOwner->GetStyle() & WS_CHILD)
			pWndPopupOwner = pWndPopupOwner->GetParent();

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y,
			pWndPopupOwner);
	}
}

