#if !defined(AFX_GRAPHVIEW_H__F46A9732_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_)
#define AFX_GRAPHVIEW_H__F46A9732_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// GraphView.h : wb_[ t@C
//
#include "CurveFitDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CGraphView r[

class CGraphView : public CScrollView
{
protected:
	CGraphView();           // IɎgpveNg RXgN^B
	DECLARE_DYNCREATE(CGraphView)

	LOGFONT m_ViewLogFont;

// Agr[g
public:
	CCurveFitDoc *GetDocument() { return (CCurveFitDoc*)CView::GetDocument(); };
	CGraphFrameArray *GetGraphFrameArray() { return GetDocument()->GetGraphFrameArray(); };
	CGraphFrame *GetGraphFrame(int n) { return GetDocument()->GetGraphFrame(n); };
// Iy[V
public:
	CPoint m_PrevPoint;
	CPoint m_StartPoint;
	bool m_IsSpecifyingRegion;

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CGraphView)
	protected:
	virtual void OnDraw(CDC* pDC);      // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual void OnInitialUpdate();     // \zAŏ̏B
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView);
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Cve[V
protected:
	virtual ~CGraphView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CGraphView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnViewSelectfont();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnFilePrintPreview();
	afx_msg void OnFilePrint();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_GRAPHVIEW_H__F46A9732_CD03_11D1_B2C2_0000F81EA28D__INCLUDED_)
